<?php

require_once 'batchexportperm.civix.php';
// use CRM_Batchexportperm_ExtensionUtil as E;

/**
 * Implements hook_civicrm_config().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_config
 */
function batchexportperm_civicrm_config(&$config) {
  _batchexportperm_civix_civicrm_config($config);
}

/**
 * Implements hook_civicrm_xmlMenu().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_xmlMenu
 */
function batchexportperm_civicrm_xmlMenu(&$files) {
  _batchexportperm_civix_civicrm_xmlMenu($files);
}

/**
 * Implements hook_civicrm_install().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_install
 */
function batchexportperm_civicrm_install() {
  _batchexportperm_civix_civicrm_install();
}

/**
 * Implements hook_civicrm_postInstall().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_postInstall
 */
function batchexportperm_civicrm_postInstall() {
  _batchexportperm_civix_civicrm_postInstall();
}

/**
 * Implements hook_civicrm_uninstall().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_uninstall
 */
function batchexportperm_civicrm_uninstall() {
  _batchexportperm_civix_civicrm_uninstall();
}

/**
 * Implements hook_civicrm_enable().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_enable
 */
function batchexportperm_civicrm_enable() {
  _batchexportperm_civix_civicrm_enable();
}

/**
 * Implements hook_civicrm_disable().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_disable
 */
function batchexportperm_civicrm_disable() {
  _batchexportperm_civix_civicrm_disable();
}

/**
 * Implements hook_civicrm_upgrade().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_upgrade
 */
function batchexportperm_civicrm_upgrade($op, CRM_Queue_Queue $queue = NULL) {
  return _batchexportperm_civix_civicrm_upgrade($op, $queue);
}

/**
 * Implements hook_civicrm_managed().
 *
 * Generate a list of entities to create/deactivate/delete when this module
 * is installed, disabled, uninstalled.
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_managed
 */
function batchexportperm_civicrm_managed(&$entities) {
  _batchexportperm_civix_civicrm_managed($entities);
}

/**
 * Implements hook_civicrm_caseTypes().
 *
 * Generate a list of case-types.
 *
 * Note: This hook only runs in CiviCRM 4.4+.
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_caseTypes
 */
function batchexportperm_civicrm_caseTypes(&$caseTypes) {
  _batchexportperm_civix_civicrm_caseTypes($caseTypes);
}

/**
 * Implements hook_civicrm_angularModules().
 *
 * Generate a list of Angular modules.
 *
 * Note: This hook only runs in CiviCRM 4.5+. It may
 * use features only available in v4.6+.
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_angularModules
 */
function batchexportperm_civicrm_angularModules(&$angularModules) {
  _batchexportperm_civix_civicrm_angularModules($angularModules);
}

/**
 * Implements hook_civicrm_alterSettingsFolders().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_alterSettingsFolders
 */
function batchexportperm_civicrm_alterSettingsFolders(&$metaDataFolders = NULL) {
  _batchexportperm_civix_civicrm_alterSettingsFolders($metaDataFolders);
}

/**
 * Implements hook_civicrm_entityTypes().
 *
 * Declare entity types provided by this module.
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_entityTypes
 */
function batchexportperm_civicrm_entityTypes(&$entityTypes) {
  _batchexportperm_civix_civicrm_entityTypes($entityTypes);
}

/**
 * Implements hook_civicrm_permission().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_permission
 */
function batchexportperm_civicrm_permission(&$permissions) {
  $prefix = ts('CiviCRM') . ': ';
  $permissions['edit exported contributions'] = [
    $prefix . ts('Edit exported contributions'),
    ts('Edit exported contributions'),
  ];
}

/**
 * Implements hook_civicrm_links().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_links
 */
function batchexportperm_civicrm_links($op, $objectName, $objectId, &$links, &$mask, &$values) {
  if ($op == 'contribution.selector.row' && $objectName == 'Contribution') {
    if (!_batchexportperm_civicrm_allow_contribution_to_edit($objectId)) {
      foreach ($links as $key => $link) {
        if ($link['name'] == 'Edit') {
          unset($links[$key]);
        }
      }
    }
  }
}

/**
 * Implements hook_civicrm_pre().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_pre
 */
function batchexportperm_civicrm_pre($op, $objectName, $id, &$params) {
  if ($op == 'edit' && $objectName == 'Contribution') {
    _batchexportperm_civicrm_check_permission($id);
  }

  if ($objectName == 'Batch' && $op == 'edit') {
    if (!empty($params['status_id'])) {
      $exportedStatusId = CRM_Core_PseudoConstant::getKey('CRM_Batch_BAO_Batch', 'status_id', 'Exported');
      if ($exportedStatusId != $params['status_id']) {
        return NULL;
      }
      $oldStatusId = civicrm_api3('Batch', 'getvalue', [
        'return' => "status_id",
        'id' => $id,
      ]);
      if ($oldStatusId != $params['status_id']) {
        CRM_Core_Smarty::singleton()->assign("batch_status_change_{$id}", TRUE);
      }
    }
  }
}

/**
 * Implements hook_civicrm_apiWrappers().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_apiWrappers
 */
function batchexportperm_civicrm_apiWrappers(&$wrappers, $apiRequest) {
  if ($apiRequest['entity'] == 'Contribution' && $apiRequest['action'] == 'create') {
    $contibutionId = CRM_Utils_Array::value('id', $apiRequest['params']);
    _batchexportperm_civicrm_check_permission($contibutionId, 'exception');
  }
}

/**
 * Implements hook_civicrm_preProcess().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_preProcess
 */
function batchexportperm_civicrm_preProcess($formName, &$form) {
  if ($formName == 'CRM_Contribute_Form_Contribution' && $form->_action & CRM_Core_Action::UPDATE) {
    $contributionId = $form->_id;
    _batchexportperm_civicrm_check_permission($contributionId);
  }
}

/**
 * Check if user has permission to update contribution.
 *
 * @param int $contributionId
 * @param string $errorType
 */
function _batchexportperm_civicrm_check_permission($contributionId, $errorType = NULL) {
  if (empty($contributionId) || _batchexportperm_civicrm_allow_contribution_to_edit($contributionId)) {
    return FALSE;
  }
  $message = ts('You do not have the necessary permission to edit this contribution.');
  if ($errorType == 'exception') {
    throw new API_Exception($message);
  }
  else {
    CRM_Core_Error::statusBounce($message);
  }
}

/**
 * Check if user has permission to update contribution.
 *
 * @param int $contributionId
 */
function _batchexportperm_civicrm_allow_contribution_to_edit($contributionId) {

  $exportDate = _getExportData($contributionId);

  if (!$exportDate || CRM_Core_Permission::check('edit exported contributions')) {
    return TRUE;
  }
  return FALSE;
}

/**
 * Given a contribution ID, return its batch export date.
 *
 * @param int $contributionId
 * @return string|null This contribution's batch export date if it exists.
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_post
 */
function _getExportData($contributionId) {
  // See if the contribution has been exported.
  // Man, I wish API4 actually worked.
  $query = "SELECT cb.modified_date "
  . "FROM civicrm_entity_batch ceb "
  . "JOIN civicrm_batch cb on ceb.batch_id = cb.id AND ceb.entity_table = 'civicrm_financial_trxn' "
  . "JOIN civicrm_entity_financial_trxn ceft ON ceft.entity_table = 'civicrm_contribution' AND ceb.entity_id = ceft.financial_trxn_id "
  . "JOIN civicrm_option_value cov on cov.value = cb.status_id  AND cov.label = 'Exported' "
  . "JOIN civicrm_option_group cog ON cov.option_group_id = cog.id AND cog.name = 'batch_status' "
  . "WHERE ceft.entity_id = %1";
  $params = [1 => [$contributionId, 'Integer']];
  $date = CRM_Core_DAO::singleValueQuery($query, $params);
  return CRM_Utils_Date::customFormat($date);
}

/**
 * Display batch eport info on the contribution.
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_buildForm
 */
function batchexportperm_civicrm_buildForm($formName, $form) {
  if ($formName == 'CRM_Contribute_Form_ContributionView' ||
  $formName == 'CRM_Contribute_Form_Contribution' && !empty($form->_id)) {
    // ContributionView doesn't pass the ID in the form object?  Really?
    $contributionId = $form->_id ?? CRM_Utils_Request::retrieve('id', 'Positive');
    $exportDate = _getExportData($contributionId);
    $form->assign('exportDate', $exportDate);
    CRM_Core_Region::instance('page-body')->add(['template' => "CRM/Batchexportperm/Form/BatchDetails.tpl"]);
    CRM_Core_Resources::singleton()->addScriptFile('org.agbu.batchexportperm', 'js/exportDate.js');
  }
}
